# HG changeset patch
# User Pavel Pautov <p.pautov@f5.com>
# Date 1714635432 25200
#      Thu May 02 00:37:12 2024 -0700
# Node ID e77245d44adcbfe46b66c3a3641f573aec9334b7
# Parent  86af12e98fbf116e9b0c019e9ccf1a50f0cf9e24
gRPC: fix chain links "leak" for client streaming (ticket #2614).

Based on a patch by Sangmin Lee.

diff --git a/src/http/modules/ngx_http_grpc_module.c b/src/http/modules/ngx_http_grpc_module.c
--- a/src/http/modules/ngx_http_grpc_module.c
+++ b/src/http/modules/ngx_http_grpc_module.c
@@ -1459,7 +1459,9 @@ ngx_http_grpc_body_output_filter(void *d
             last = 1;
         }
 
+        cl = in;
         in = in->next;
+        ngx_free_chain(r->pool, cl);
     }
 
     ctx->in = in;
